/* Tabela CCORFORN */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CCORFORN */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela de conta corrente por fornecedor.
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_CCORFORN
AFTER DELETE OR INSERT OR UPDATE
ON CCORFORN FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_IDTIPOOPER := '';
   NMUSUARIO(V_NMOPERADOR);

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      V_IDTIPOOPER   := '3';
      V_ITPESQ       := :OLD.CDFORNECED||:OLD.CDBANCFORN||:OLD.CDAGENFORN||:OLD.CDCCORFORN;
      V_DESC         := 'Codigo '          || '' || NVL(:OLD.CDFORNECED,'')||' '||
                        'Banco '           || '' || NVL(:OLD.CDBANCFORN,'')||' '||
                        'Agencia '         || '' || NVL(:OLD.CDAGENFORN,'')||' '||
                        'Conta Corrente '  || '' || NVL(:OLD.CDCCORFORN,'')||' '||
                        'Tipo Insc '       || '' || NVL(:OLD.IDTPICNABFOR,'')||' '||
                        'Inscrio '       || '' || NVL(:OLD.NRINSCNABFOR,'')||' '||
                        'Id Preferencial ' || '' || NVL(:OLD.IDCCORFORNPREF,'');
   ELSE
      IF UPDATING THEN
         V_DESC         := 'Codigo '          || '' || NVL(:OLD.CDFORNECED,'')||' '||
                           'Banco '           || '' || NVL(:OLD.CDBANCFORN,'')||' '||
                           'Agencia '         || '' || NVL(:OLD.CDAGENFORN,'')||' '||
                           'Conta Corrente '  || '' || NVL(:OLD.CDCCORFORN,'')||' '||
                           'Tipo Insc '       || '' || NVL(:OLD.IDTPICNABFOR,'')||' '||
                           'Inscrio '       || '' || NVL(:OLD.NRINSCNABFOR,'')||' '||
                           'Id Preferencial ' || '' || NVL(:OLD.IDCCORFORNPREF,'');
         V_ITPESQ := :OLD.CDFORNECED||:OLD.CDBANCFORN||:OLD.CDAGENFORN||:OLD.CDCCORFORN;
         V_IDTIPOOPER := '2';
      ELSE
         V_IDTIPOOPER   := '1';
         V_ITPESQ       := :NEW.CDFORNECED||:NEW.CDBANCFORN||:NEW.CDAGENFORN||:NEW.CDCCORFORN;
         V_DESC         := 'Codigo '          || '' || NVL(:NEW.CDFORNECED,'')||' '||
                           'Banco '           || '' || NVL(:NEW.CDBANCFORN,'')||' '||
                           'Agencia '         || '' || NVL(:NEW.CDAGENFORN,'')||' '||
                           'Conta Corrente '  || '' || NVL(:NEW.CDCCORFORN,'')||' '||
                           'Tipo Insc '       || '' || NVL(:NEW.IDTPICNABFOR,'')||' '||
                           'Inscrio '       || '' || NVL(:NEW.NRINSCNABFOR,'')||' '||
                           'Id Preferencial ' || '' || NVL(:NEW.IDCCORFORNPREF,'');
      END IF;
  END IF;
   V_DESC := SUBSTR(V_DESC, 1, 300);
   INSERT INTO LOGOPERA
      (NMTABELA,
       DTOPERACAO,
       NMRESPOPER,
       IDTIPOOPER,
       DSOPERACAO,
       CDPESQITEM,
       DSRDMUSUOPER,
       DSENDUSUOPER,
       DSNMUSUOPER,
       DSMETUSUOPER,
       CDORESPOPER)
   VALUES
      ('CCORFORN',
       SYSDATE,
       NVL(V_NMOPERADOR,' '),
       V_IDTIPOOPER,
       V_DESC,
       V_ITPESQ,
       V_DSSERVERRDM,
       V_DSREMOTEADDR,
       V_DSREMOTEHOST,
       V_DSSERVMETHOD,
       V_DSREMOTEOPER);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CCORFORN','6.49.080'); END;
/


